]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
add information messages
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devives
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by defult, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 PROFILES=~/.autorandr/
50 CONFIG=~/.autorandr.conf
51
52 CHANGE_PROFILE=0
53 FORCE_LOAD=0
54 DEFAULT_PROFILE=""
55 SAVE_PROFILE=""
56
57 FP_METHODS="setup_fp_xrandr_edid setup_fp_sysfs_edid"
58 CURRENT_CFG_METHOD="current_cfg_xrandr"
59 LOAD_METHOD="load_cfg_xrandr"
60
61 SCRIPTNAME="$(basename $0)"
62 # when called as autodisper/auto-disper, we assume different defaults
63 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
64         echo "Assuming disper defaults..." >&2
65         FP_METHODS="setup_fp_disper"
66         CURRENT_CFG_METHOD="current_cfg_disper"
67         LOAD_METHOD="load_cfg_disper"
68 fi
69
70 if [ -f $CONFIG ]; then
71         echo "Loading configuration from '$CONFIG'" >&2
72         . $CONFIG
73 fi
74
75 setup_fp_xrandr_edid() {
76         $XRANDR -q --verbose | awk '
77         /^[^ ]+ (dis)?connected / { DEV=$1; }
78         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
79         END { for (X in ID) { print X " " ID[X]; } }'
80 }
81
82 setup_fp_sysfs_edid() {
83         # xrandr triggers the reloading of EDID data
84         $XRANDR -q > /dev/null
85         # hash the EDIDs of all _connected_ devices
86         for P in /sys/class/drm/card*-*/; do
87                 # nothing found
88                 [ ! -d "$P" ] && continue
89                 if grep -q "^connected$" < "${P}status"; then
90                         echo -n "$(basename "$P") "
91                         md5sum ${P}edid | awk '{print $1}'
92                 fi
93         done
94 }
95
96 setup_fp_disper() {
97         $DISPER -l | grep '^display '
98 }
99
100 setup_fp() {
101         local FP="";
102         for M in $FP_METHODS; do
103                 FP="$($M)"
104                 if [ -n "$FP" ]; then
105                         break
106                 fi
107         done
108         if [ -z "$FP" ]; then
109                 echo "Unable to fingerprint display configuration" >&2
110                 return
111         fi
112         echo "$FP"
113 }
114
115 current_cfg_xrandr() {
116         $XRANDR -q | awk '
117         /^[^ ]+ disconnected / {
118         print "output "$1;
119                 print "off";
120         }
121         /^[^ ]+ connected / {
122                 split($3, A, "+");
123                 print "output "$1;
124                 print "mode "A[1];
125                 print "pos "A[2]"x"A[3];
126         }'
127 }
128
129 current_cfg_disper() {
130         $DISPER -p
131 }
132
133 current_cfg() {
134         $CURRENT_METHOD;
135 }
136
137 blocked() {
138         local PROFILE="$1"
139         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
140
141         "$PROFILES/$PROFILE/block" "$PROFILE"
142 }
143
144 config_equal() {
145         local PROFILE="$1"
146         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
147                 echo "Config already loaded"
148                 return 0
149         else
150                 return 1
151         fi
152 }
153
154 load_cfg_xrandr() {
155         sed 's!^!--!' "$1" | xargs $XRANDR
156 }
157
158 load_cfg_disper() {
159         $DISPER < -i < "$1"
160 }
161
162 load() {
163         local PROFILE="$1"
164         local CONF="$PROFILES/$PROFILE/config"
165         if [ -e "$CONF" ] ; then
166                 echo " -> loading profile $PROFILE"
167                 $LOAD_METHOD "$CONF"
168
169                 [ -x "$PROFILES/$PROFILE/postswitch" ] && \
170                         "$PROFILES/$PROFILE/postswitch" "$PROFILE"
171                 [ -x "$PROFILES/postswitch" ] && \
172                         "$PROFILES/postswitch" "$PROFILE"
173         fi
174 }
175
176 help() {
177         cat <<EOH
178 Usage: $SCRIPTNAME [options]
179
180 -h, --help              get this small help
181 -c, --change            reload current setup
182 -s, --save <profile>    save your current setup to profile <profile>
183 -l, --load <profile>    load profile <profile>
184 -d, --default <profile> make profile <profile> the default profile 
185 --force                 force (re)loading of a profile
186 --fingerprint           fingerprint your current hardware setup
187
188  To prevent a profile from being loaded, place a script call "block" in its
189  directory. The script is evaluated before the screen setup is inspected, and
190  in case of it returning a value of 0 the profile is skipped. This can be used
191  to query the status of a docking station you are about to leave.
192
193  If no suitable profile can be identified, the current configuration is kept.
194  To change this behaviour and switch to a fallback configuration, specify
195  --default <profile>.
196
197  Another script called "postswitch "can be placed in the directory
198  ~/.autorandr as well as in any profile directories: The scripts are executed
199  after a mode switch has taken place and can notify window managers.
200
201  When called by the name "autodisper" or "auto-disper", the script uses "disper"
202  instead of "xrandr" to detect, configure and save the display configuration.
203
204 EOH
205         exit
206 }
207 # process parameters
208 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,help -- "$@")
209 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
210 eval set -- "$OPTS"
211
212 while true; do
213         case "$1" in
214                 -c|--change) CHANGE_PROFILE=1; shift ;;
215                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
216                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
217                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
218                 -h|--help) help ;; 
219                 --force) FORCE_LOAD=1; shift ;;
220                 --fingerprint) setup_fp; exit 0;;
221                 --) shift; break ;;
222                 *) echo "Error: $1"; exit 1;;
223         esac
224 done
225
226 CURRENT_SETUP="$(setup_fp)"
227
228 if [ -n "$SAVE_PROFILE" ]; then
229         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
230         mkdir -p "$PROFILES/$SAVE_PROFILE"
231         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
232         current_cfg > "$PROFILES/$SAVE_PROFILE/config"
233         exit 0
234 fi
235
236 if [ -n "$LOAD_PROFILE" ]; then
237         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
238         exit $?
239 fi
240
241 for SETUP_FILE in $PROFILES/*/setup; do
242         if ! [ -e $SETUP_FILE ]; then
243                 break
244         fi
245         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
246         echo -n "$PROFILE"
247
248         if blocked "$PROFILE"; then
249                 echo " (blocked)"
250                 continue
251         fi
252
253         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
254         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
255                 echo " (detected)"
256                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
257                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
258                                 load "$PROFILE"
259                         fi
260                 fi
261                 # found the profile, exit with success
262                 exit 0
263         else
264                 echo ""
265         fi
266 done
267
268 # we did not find the profile, load default
269 if [ -n "$DEFAULT_PROFILE" ]; then
270         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
271         load "$DEFAULT_PROFILE"
272 fi
273 exit 1